// Code generated by mockery v2.53.0. DO NOT EDIT.

package pipelinetemplate

import (
	context "context"
	io "io"

	db "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/db"

	mock "github.com/stretchr/testify/mock"

	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockService is an autogenerated mock type for the Service type
type MockService struct {
	mock.Mock
}

// CreatePipelineTemplate provides a mock function with given fields: ctx, input
func (_m *MockService) CreatePipelineTemplate(ctx context.Context, input *CreatePipelineTemplateInput) (*models.PipelineTemplate, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for CreatePipelineTemplate")
	}

	var r0 *models.PipelineTemplate
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *CreatePipelineTemplateInput) (*models.PipelineTemplate, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *CreatePipelineTemplateInput) *models.PipelineTemplate); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.PipelineTemplate)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *CreatePipelineTemplateInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeletePipelineTemplate provides a mock function with given fields: ctx, input
func (_m *MockService) DeletePipelineTemplate(ctx context.Context, input *DeletePipelineTemplateInput) error {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for DeletePipelineTemplate")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *DeletePipelineTemplateInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetPipelineTemplateByID provides a mock function with given fields: ctx, id
func (_m *MockService) GetPipelineTemplateByID(ctx context.Context, id string) (*models.PipelineTemplate, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetPipelineTemplateByID")
	}

	var r0 *models.PipelineTemplate
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.PipelineTemplate, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.PipelineTemplate); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.PipelineTemplate)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPipelineTemplateByPRN provides a mock function with given fields: ctx, prn
func (_m *MockService) GetPipelineTemplateByPRN(ctx context.Context, prn string) (*models.PipelineTemplate, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetPipelineTemplateByPRN")
	}

	var r0 *models.PipelineTemplate
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.PipelineTemplate, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.PipelineTemplate); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.PipelineTemplate)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPipelineTemplateData provides a mock function with given fields: ctx, id
func (_m *MockService) GetPipelineTemplateData(ctx context.Context, id string) (io.ReadCloser, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetPipelineTemplateData")
	}

	var r0 io.ReadCloser
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (io.ReadCloser, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) io.ReadCloser); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(io.ReadCloser)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPipelineTemplates provides a mock function with given fields: ctx, input
func (_m *MockService) GetPipelineTemplates(ctx context.Context, input *GetPipelineTemplatesInput) (*db.PipelineTemplatesResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetPipelineTemplates")
	}

	var r0 *db.PipelineTemplatesResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetPipelineTemplatesInput) (*db.PipelineTemplatesResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetPipelineTemplatesInput) *db.PipelineTemplatesResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*db.PipelineTemplatesResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetPipelineTemplatesInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPipelineTemplatesByIDs provides a mock function with given fields: ctx, idList
func (_m *MockService) GetPipelineTemplatesByIDs(ctx context.Context, idList []string) ([]models.PipelineTemplate, error) {
	ret := _m.Called(ctx, idList)

	if len(ret) == 0 {
		panic("no return value specified for GetPipelineTemplatesByIDs")
	}

	var r0 []models.PipelineTemplate
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, []string) ([]models.PipelineTemplate, error)); ok {
		return rf(ctx, idList)
	}
	if rf, ok := ret.Get(0).(func(context.Context, []string) []models.PipelineTemplate); ok {
		r0 = rf(ctx, idList)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]models.PipelineTemplate)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, []string) error); ok {
		r1 = rf(ctx, idList)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UploadPipelineTemplate provides a mock function with given fields: ctx, input
func (_m *MockService) UploadPipelineTemplate(ctx context.Context, input *UploadPipelineTemplateInput) error {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for UploadPipelineTemplate")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *UploadPipelineTemplateInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// NewMockService creates a new instance of MockService. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockService(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockService {
	mock := &MockService{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
